#include "stdafx.h"
#include "UpdaterDocument.h"
#include "CheckServiceUpgradeHelper.h"
#include "StartConfigurationHelper.h"
#include <atlcomtime.h>


namespace tipupdater
{

CheckServiceUpgradeHelper::CheckServiceUpgradeHelper( TipServiceData *service ) : m_service(service)
{

}

CString CheckServiceUpgradeHelper::GetGuid()
{
	return m_service->GetID();
}

CString CheckServiceUpgradeHelper::GetServiceCheckTime()
{
	ATLASSERT(m_service);
	if( NULL == m_service )
		return _T("");

	IDataContext *dataContext = m_service->GetDataContext();
	CComVariant checkTime = dataContext->GetProperty(_T("event_check_time"));
	CString strCheckTime = checkTime;
	return strCheckTime;
}

void CheckServiceUpgradeHelper::SetServiceCheckTime( CString check_time )
{
	ATLASSERT(m_service );
	if( NULL == m_service )
		return;

	CComVariant checkTime = check_time;

	IDataContext *dataContext = m_service->GetDataContext();
	dataContext->SetProperty(_T("event_check_time"), checkTime);
}

BOOL CheckServiceUpgradeHelper::IsOverCheckTime()
{
	ATLASSERT(m_service);
	if( NULL == m_service )
		return TRUE;

	CString strCheckTIme = GetServiceCheckTime();
	if( strCheckTIme == _T("") )
		return TRUE;

	COleDateTime checkTime;
	checkTime.ParseDateTime(strCheckTIme);
	COleDateTime nowTime = COleDateTime::GetCurrentTime();

	if( nowTime < checkTime )
		return FALSE;

	return TRUE;
}

void CheckServiceUpgradeHelper::SetCheckTimeFromCurrentTime( int adder_time )
{
	ATLASSERT(m_service);

	COleDateTime nowTime = COleDateTime::GetCurrentTime();

	nowTime += COleDateTimeSpan( 0, 0, 0, adder_time );

	CString strNowTime = nowTime.Format(_T("%Y-%m-%d %H:%M:%S")); 
	SetServiceCheckTime( strNowTime );
}

};